//////////////////////////////////////////////////////////////////////////
//
// Hall A analyzer replay script Example
//
//////////////////////////////////////////////////////////////////////////
//	
//	Author : Jin Huang (jinhuang@jlab.org)   May 2008
//
//////////////////////////////////////////////////////////////////////////



using namespace std;

void BigBiteScalar(Int_t runnumber=0,Int_t all=0,Int_t fstEvt=0,Bool_t QuietRun = kFALSE)
{

//   //Add BigBite 
//   THaBigBite* pB=new THaBigBite("BB","BigBite"); 
//   //THaBBTotalShower* ts=new THaBBTotalShower("ts","BigBite total shower");
//   //pB->AddDetector(ts);
//   pB->AddDetector(new TreeSearch::MWDC("mwdc","MWDC",pB));
//   pB->AddDetector( new THaScintPlaneDet( "s", "BB Scintillator",pB ));
//   pB->AddDetector( new THaScintPlaneDet( "sum", "BB Total sum",pB));
//   pB->AddDetector( new THaScintPlaneDet( "psum", "BB Preshower sum",pB));
//   pB->AddDetector( new THaBBTotalShower( "ts", "BB Total shower",pB));
//   pB->AddDetector( new THaCherenkov("cer", "gas Cerenkov counter", pB ));
	// 
	THaApparatus* B = new THaIdealBeam("B","Idea Beam, for Test Only");
	gHaApps->Add( B );
 
	cout<<"replay: Adding BigBite Helicity"<< endl;
	B->AddDetector( new THaADCHelicity("adchel.BB","Beam helicity BB") );
	B->AddDetector( new THaADCHelicity("adchel2.BB","Beam helicity BB") );
//    B->AddDetector( new THaG0Helicity("g0hel.L","Left arm G0 helicity

//   gHaApps->Add(new THaUnRasteredBeam("BBurb","Unrastered beam"));
//   gHaApps->Add(new THaRasteredBeam("BBrb","Rastered Beam"));
//   pB->MountOptics(new THaOpticsAnalytical("optics","Analytical Bigbite Optics model",pB,"BBurb"));
//   gHaPhysics->Add( new THaGoldenTrack("BB.gold","Golden track for Bigbite", "BB") );


  //Decode miscellaneous things
// 	THaApparatus* DECDAT = new THaDecData("DBB","Misc. Decoder Data");
// 	gHaApps->Add( DECDAT );
//   gHaApps->Add(pB);
    
	////////////////////////////////////////
  //   Scalars
	////////////////////////////////////////
  // add scalers

	cout<<"replay: Adding Left Scalar ..."<<endl;
  	THaScalerGroup* LeftScalers = new THaScalerGroup("Left");
  	gHaScalers->Add(LeftScalers);

  	


        cout<<"replay: Adding BigBite Scalar ..."<<endl;
  	THaScalerGroup* BigBiteScalers = new THaScalerGroup("bbite");
  	gHaScalers->Add(BigBiteScalers);

        cout<<"replay: Adding evBigBite Scalar ..."<<endl;
  	THaScalerGroup* evBigBiteScalers = new THaScalerGroup("evbbite");
  	gHaScalers->Add(evBigBiteScalers);
        
        



// 	gHaScalers->Add(new THaScalerGroup("evLeft"));
// 	gHaScalers->Add(new THaScalerGroup("evbbite"));


	////////////////////////////////////////
  //   BB Norm Ana
	////////////////////////////////////////
	char buff[1000]="";
	sprintf(buff,"./summaryfiles/BBScalar%d.log",runnumber);

	//cout<<"replay: Adding BBNormAna & saving result to "<<buff<<endl;
	//BBNormAna* norm = new BBNormAna("N","Normalization Analysis",buff,8);
	//gHaPhysics->Add(norm);
 
	////////////////////////////////////////
  //   Do replay
	////////////////////////////////////////
	THaAnalyzer* analyzer = THaAnalyzer::GetInstance();
	if( !analyzer ) {
		analyzer = new THaAnalyzer;
	}
// 	analyzer->EnableBenchmarks();
	//analyzer->EnableHelicity();
	analyzer->EnableScalers();
  //analyzer->EnableSlowControl();
	analyzer->SetMarkInterval(20000);
  	
//----------------------- DO REPLAY ---------------------------------
        
        THaEvent* event = new THaEvent;
  
  	int nrun, nev;
  	int found = 0;

  	char filename0[300];  
  	char filename1[300];
  	char filename2[300];
    
  	FILE *fd;
  	const char path[300] = "./raw";
  
  	cout << "Run number?\n";
  	cin >> nrun;
  	if( nrun<0 ) break;
    
  	cout << "Number of events to analyze (-1 for all) ?\n";
  	cin >> nev;
    
  	sprintf(filename0,"%s/e05102_%d.dat.0",path,nrun);
  	cout<<"Run No.0 : "<<filename0<<endl;

  	sprintf(filename1,"%s/e05102_%d.dat.1",path,nrun);
  	cout<<"Run No.1 : "<<filename1<<endl;

  	sprintf(filename2,"%s/e05102_%d.dat.2",path,nrun);
  	cout<<"Run No.2 : "<<filename2<<endl;

  
  	analyzer->SetEvent( event );
  	char outname[300];
  	sprintf(outname,"./eed_BigBiteScalar_%d.root",nrun);
  	analyzer->SetOutFile( outname );
  	analyzer->SetOdefFile("BigBiteScalar.odef");
  	//analyzer->SetCutFile("replay_L.cdef");
  	// File to record cuts accounting information
  	char sumname[300];
  	sprintf(sumname,"./summaryfiles/Log_BigBiteScalar.log");
  	analyzer->SetSummaryFile(sumname); // optional

  	THaRun run0(filename0);
  	THaRun run1(filename1);
  	THaRun run2(filename2);

  
  	if(nev>-1) {
    	  run0.SetLastEvent(nev);
    	  analyzer->Process(run0);     // start the actual analysis
   	}
  	else {
     	  analyzer->Process(run0);     // start the actual analysis
    	  analyzer->Process(run1);     // start the actual analysis
    	  analyzer->Process(run2);     // start the actual analysis
  	}
  
  	cout<<"-----------YOU JUST ANALYZED RUN number -------- "<<nrun<<"."<<endl;
	//LeftScalers->PrintSummary();
  	//BigBiteScalers->PrintSummary();
}
